package com.gic.haoban.manage.service.service.impl;

import java.util.Date;
import java.util.Set;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.service.dao.mapper.StaffMapper;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.service.StaffService;
import com.github.pagehelper.Page;

@Service
public class StaffServiceImpl implements StaffService {
	
	@Autowired
	StaffMapper mapper;

	@Override
	public TabHaobanStaff selectById(String id) {
		
		return mapper.selectByPrimaryKey(id);
	}

	@Override
	public TabHaobanStaff selectByNationcodeAndPhoneNumber(String wxEnterpriseId,String nationcode, String phoneNumber) {
		return mapper.selectByNationcodeAndPhoneNumber(wxEnterpriseId,nationcode,phoneNumber);
	}

	@Override
	public String add(TabHaobanStaff tab) {
		Date now = new Date();
		tab.setCreateTime(now);
		tab.setUpdateTime(now);
		if(StringUtils.isBlank(tab.getStaffId())){
			tab.setStaffId(StringUtil.randomUUID());
		}
		tab.setStatusFlag(1);
		if(StringUtils.isBlank(tab.getWxUserId())){
			tab.setWxUserId(tab.getStaffId());
		}
		mapper.insertSelective(tab);
		return tab.getStaffId();
	}

	@Override
	public Page<TabHaobanStaff> pageStaff(Set<String> staffIds, Integer activeFlag, String keyword) {
		
		return mapper.pageStaff(staffIds,activeFlag,keyword);
	}

	@Override
	public TabHaobanStaff selectByUserId(String userId) {
		
		return mapper.selectByUserId(userId);
	}

	@Override
	public void updateByPrimaryKey(TabHaobanStaff tab) {
		mapper.updateByPrimaryKeySelective(tab);		
	}

	@Override
	public int delByuserid(String staffId) {
		TabHaobanStaff staff = new TabHaobanStaff();
		staff.setStaffId(staffId);
		staff.setStatusFlag(0);
		return this.mapper.updateByPrimaryKeySelective(staff);
	}

}
