package com.gic.haoban.manage.service.service.out.impl;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.service.MemberUnionRelatedService;
import com.gic.haoban.manage.service.service.StaffService;

@Service
public class MemberUnionidRelatedApiServiceImpl implements MemberUnionidRelatedApiService{
	private static final Logger log = LogManager.getLogger(MemberUnionidRelatedApiServiceImpl.class);
	@Autowired
	private MemberUnionRelatedService memberUnionRelatedService;
	@Autowired
	private StaffService staffService;
	@Autowired
	private QywxUserApiService qywxUserApiService;
	@Autowired
	private com.gic.enterprise.api.service.StoreGroupService gicDepartmentService;

	@Override
	public MemberUnionidRelatedDTO getByUnionId(String staffId, String unionid) {
		TabHaobanStaff staff = staffService.selectById(staffId);
		if(staff == null){
			return null;
		}
		return memberUnionRelatedService.getByUnionId(staff.getWxUserId(),unionid);
	}
	@Override
	public String addMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		this.getExternalUserUnionid(dto);
		return memberUnionRelatedService.addMemberUnionidRelated(dto);
	}
	@Override
	public void delMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
		this.getExternalUserUnionid(dto);
		memberUnionRelatedService.delMemberUnionidRelated(dto);
		
	}

	private void getExternalUserUnionid(MemberUnionidRelatedDTO dto){
		String externalUseridInfo = this.qywxUserApiService.getExternalUseridInfo(dto.getCorpid(), dto.getSuiteid(), dto.getExternalUserid());
		if(StringUtils.isNotBlank(externalUseridInfo)){
			JSONObject jsonObject = JSON.parseObject(externalUseridInfo);
			dto.setUnionid(jsonObject.getString("unionid"));
		}
	}
}
