package com.gic.haoban.manage.service.service.out.impl;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import cn.hutool.core.collection.CollectionUtil;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.gic.api.base.commons.JSONResponse;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.commons.util.EntityUtil;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.common.utils.UuidUtil;
import com.gic.haoban.manage.api.dto.DepartmentDTO;
import com.gic.haoban.manage.api.dto.StaffDTO;
import com.gic.haoban.manage.api.dto.StaffDepartmentRelatedDTO;
import com.gic.haoban.manage.api.dto.SyncJsonColumnDTO;
import com.gic.haoban.manage.api.dto.WxEnterpriseDTO;
import com.gic.haoban.manage.api.service.StaffApiService;
import com.gic.haoban.manage.service.dao.mapper.StaffDepartmentRelatedMapper;
import com.gic.haoban.manage.service.dao.mapper.StaffMapper;
import com.gic.haoban.manage.service.entity.TabHaobanDepartment;
import com.gic.haoban.manage.service.entity.TabHaobanStaff;
import com.gic.haoban.manage.service.entity.TabHaobanStaffDepartmentRelated;
import com.gic.haoban.manage.service.entity.TabHaobanWxApplication;
import com.gic.haoban.manage.service.service.DepartmentService;
import com.gic.haoban.manage.service.service.StaffDepartmentRelatedService;
import com.gic.haoban.manage.service.service.StaffService;
import com.gic.haoban.manage.service.service.WxApplicationService;
import com.gic.haoban.manage.service.service.WxEnterpriseService;
import com.gic.wechat.api.dto.qywx.UserDTO;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import com.github.pagehelper.PageHelper;

@Service
public class StaffApiServiceImpl implements StaffApiService {
	
	private static Logger logger  = LoggerFactory.getLogger(StaffApiServiceImpl.class);
	@Autowired
	StaffService staffService;
	@Autowired
	StaffMapper staffMapper;
	@Autowired
	StaffDepartmentRelatedService staffDepartmentRelatedService;
	@Autowired
	private StaffDepartmentRelatedMapper staffDepartmentRelatedMapper;
	
	@Autowired
	private QywxUserApiService qywxUserApiService;
	@Autowired
	private WxEnterpriseService wxEnterpriseService;
	@Autowired
	private WxApplicationService wxApplicationService;
	@Autowired
	private DepartmentService departmentService;
	@Autowired
	private ClerkService clerkService;
	@Autowired
	private com.gic.enterprise.api.service.DepartmentService gicDepartmentService;
	@Autowired
	private StoreService storeService;
	
	@Override
	public StaffDTO selectById(String staffId) {
		TabHaobanStaff staff = staffService.selectById(staffId);
		return EntityUtil.changeEntityByJSON(StaffDTO.class, staff);
	}

	@Override
	public StaffDTO selectByNationcodeAndPhoneNumber(String wxEnterpriseId,String nationcode, String phoneNumber) {
		TabHaobanStaff staff = staffService.selectByNationcodeAndPhoneNumber(wxEnterpriseId,nationcode,phoneNumber);
		return EntityUtil.changeEntityByJSON(StaffDTO.class, staff);
	}

	@Override
	public HaobanResponse add(StaffDTO staff, String departmentIds) {
		HaobanResponse hr  = new HaobanResponse();
		hr.setErrorCode(1);
		Integer activeFlag = staff.getActiveFlag();
		staff.setActiveFlag(0);
		Integer syncPostionFlag = staff.getSyncPostionFlag();
		if(syncPostionFlag != null && syncPostionFlag == 1){
			staff.setExtendPostion(staff.getPostion());
		}
		TabHaobanStaff tab = EntityUtil.changeEntityByJSON(TabHaobanStaff.class, staff);
		String staffId = StringUtil.randomUUID();
		tab.setStaffId(staffId);
		//调接口获取
		String wxUserId = "";
		WxEnterpriseDTO enterpriseDTO = wxEnterpriseService.selectById(staff.getWxEnterpriseId());
		TabHaobanWxApplication application = wxApplicationService.selectByWxEnterpriseIdAndApplicationType(staff.getWxEnterpriseId(),1);
		if(enterpriseDTO != null) {
			if(application != null) {
				UserDTO userDTO = new UserDTO();
				userDTO.setCorpid(enterpriseDTO.getCorpid());
				String[] departmentIdArr = departmentIds.split(",");
				Integer[] wxDepartmentIdArrIntegers = new Integer[departmentIdArr.length];
				int index = 0;
				for (String string : departmentIdArr) {
					TabHaobanDepartment tabs = departmentService.selectById(string);
					wxDepartmentIdArrIntegers[index] = Integer.parseInt(tabs.getWxDepartmentId());
					index ++;
				}
				userDTO.setDepartment(wxDepartmentIdArrIntegers);
				userDTO.setGender(staff.getSex() == null ? null:staff.getSex().toString());
				userDTO.setMobile(staff.getPhoneNumber());
				userDTO.setName(staff.getStaffName());
				userDTO.setUserid(staffId);
				userDTO.setAlias(staff.getNickName());
				userDTO.setExternalPosition(tab.getExtendPostion());
				userDTO.setPosition(tab.getPostion());
				if(activeFlag == 1) {
					userDTO.setTo_invite(true);
				}
				logger.info("【店员新增】userDTO = {}",JSON.toJSONString(userDTO));
				JSONResponse jp = qywxUserApiService.createWorkWxUser(userDTO, enterpriseDTO.getCorpid(), application.getSiteId());
				logger.info("【店员新增】jp = {}",JSON.toJSONString(jp));
				if(jp.getErrorCode() != 0) {
					hr.setErrorCode(0);
					hr.setDetailError("微信新增失败");
					return hr;
				}
				staffService.add(tab);
				wxUserId = staffId;
			}
		}
		
		
		
		if(StringUtils.isNotBlank(wxUserId)){
			String[] departmentIdArr = departmentIds.split(",");
			for (String string : departmentIdArr) {
				StaffDepartmentRelatedDTO related = new StaffDepartmentRelatedDTO();
				related.setDepartmentId(string);
				related.setNationCode(staff.getNationCode());
				related.setPhoneNumber(staff.getPhoneNumber());
				related.setStaffId(staffId);
				related.setWxUserId(wxUserId);
				related.setWxEnterpriseId(staff.getWxEnterpriseId());
				staffDepartmentRelatedService.add(related);
			}
		}else {
			hr.setErrorCode(0);
			hr.setMessage("微信端新增失败");
		}
		
		hr.setResult(staffId);
		
		return hr;
	}

	@Override
	public List<StaffDepartmentRelatedDTO> listStaffDepartmentByStaffId(String staffId) {
		List<TabHaobanStaffDepartmentRelated> list = staffDepartmentRelatedService.listStaffDepartmentByStaffId(staffId);
		return EntityUtil.changeEntityListByJSON(StaffDepartmentRelatedDTO.class, list);
	}

	@Override
	public Page<StaffDTO> pageStaff(String departmentId, Integer activeFlag, String keyword, BasePageInfo pageInfo) {
		
		PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
		List<TabHaobanStaffDepartmentRelated> list = staffDepartmentRelatedService.listByDepartmentId(departmentId);
		Set<String> staffIds = new HashSet<String>();
		for (TabHaobanStaffDepartmentRelated tabHaobanStaffDepartmentRelated : list) {
			staffIds.add(tabHaobanStaffDepartmentRelated.getStaffId());
		}
		if(staffIds.isEmpty()) {
			return new Page<StaffDTO>();
		}
		return  PageUtil.changePageHelperToCurrentPage(staffService.pageStaff(staffIds, activeFlag, keyword),StaffDTO.class);
	}

	@Override
	public List<StaffDTO> listByIds(List<String> staffIds) {
		if(CollectionUtil.isEmpty(staffIds)){
			return new ArrayList<StaffDTO>();
		}
		List<TabHaobanStaff> staffs = staffMapper.listByIds(staffIds);
		if(CollectionUtil.isNotEmpty(staffs)){
			List<StaffDTO> resultList = EntityUtil.changeEntityListByJSON(StaffDTO.class, staffs);
			return resultList;
		}else{
			return new ArrayList<StaffDTO>();
		}

	}

	@Override
	public void del(String staffDepartmentStaffRelatedId) {
		StaffDepartmentRelatedDTO related = staffDepartmentRelatedService.selectById(staffDepartmentStaffRelatedId);
		if(related != null) {
			List<TabHaobanStaffDepartmentRelated> relatedList = staffDepartmentRelatedService.listStaffDepartmentByStaffId(related.getStaffId());
			//只在当前门店
			if(relatedList.size() == 1) {
				TabHaobanStaff staff = staffService.selectById(relatedList.get(0).getStaffId());
				WxEnterpriseDTO enterpriseDTO = wxEnterpriseService.selectById(staff.getWxEnterpriseId());
				TabHaobanWxApplication application = wxApplicationService.selectByWxEnterpriseIdAndApplicationType(staff.getWxEnterpriseId(),1);
				if(enterpriseDTO != null) {
					if(application != null) {
						JSONResponse jp =  qywxUserApiService.deleteWorkWxUser(enterpriseDTO.getCorpid(), application.getSiteId(), staff.getWxUserId());
						logger.info("【删除成员】jp={}",JSON.toJSONString(jp));
					}
				}
				staffDepartmentRelatedService.del(related);
				staffService.delByuserid(relatedList.get(0).getStaffId());
			//走修改流程
			}else {
				String departmentIds = "";
				for (TabHaobanStaffDepartmentRelated tabHaobanStaffDepartmentRelated : relatedList) {
					if(!staffDepartmentStaffRelatedId.equals(tabHaobanStaffDepartmentRelated.getStaffDepartmentRelatedId())) {
						departmentIds += tabHaobanStaffDepartmentRelated.getDepartmentId() + ",";
					}
				}
				departmentIds  = departmentIds.substring(0,departmentIds.length() - 1);
				TabHaobanStaff staff = staffService.selectById(relatedList.get(0).getStaffId());
				staffEdit(EntityUtil.changeEntityByJSON(StaffDTO.class, staff), departmentIds);
			}
		}
		
	}

	@Override
	public void wxGetAdd(String userId,String wxEnterpriseId) {
		//获取微信用户信息
		
		TabHaobanStaff staff = staffService.selectByUserId(userId);
		if(staff == null) {
			WxEnterpriseDTO enterpriseDTO = wxEnterpriseService.selectById(wxEnterpriseId);
			TabHaobanWxApplication application = wxApplicationService.selectByWxEnterpriseIdAndApplicationType(wxEnterpriseId,1);
			if(enterpriseDTO != null) {
				if(application != null) {
					Date now = new Date();
					UserDTO user = qywxUserApiService.getWorkWxUser(enterpriseDTO.getCorpid(), application.getSiteId(), userId);
					logger.info("【新增用户】user={}",JSON.toJSONString(user));
					TabHaobanStaff tab = new TabHaobanStaff();
					tab.setWxUserId(userId);
					tab.setCreateTime(now);
					tab.setUpdateTime(now);
					tab.setStatusFlag(1);
					tab.setWxEnterpriseId(wxEnterpriseId);
					tab.setPhoneNumber(user.getMobile());
					tab.setStaffName(user.getName());
					tab.setNickName(user.getAlias());
					tab.setNationCode("86");
					tab.setSex(user.getGender() == null ? 1:Integer.parseInt(user.getGender()));
					tab.setActiveFlag(1);
					tab.setPostion(user.getPosition());
					tab.setExtendPostion(user.getExternalPosition());
					String staffId = staffService.add(tab);
					
					Integer[] departmentId = user.getDepartment();
					for (Integer integer : departmentId) {
						TabHaobanDepartment tabDepartment = departmentService.getByWxId(integer.toString(), wxEnterpriseId);
						if(tabDepartment != null){
							TabHaobanStaffDepartmentRelated tabStaff = staffDepartmentRelatedService.getDepartmentIdAndStaffId(tabDepartment.getDepartmentId(), tab.getStaffId());
							if(tabStaff == null){
								StaffDepartmentRelatedDTO dto = new StaffDepartmentRelatedDTO();
								dto.setPhoneNumber(user.getMobile());
								dto.setWxUserId(userId);
								dto.setStaffId(staffId);
								dto.setWxEnterpriseId(wxEnterpriseId);
								dto.setStatusFlag(1);
								dto.setDepartmentId(tabDepartment.getDepartmentId());
								dto.setNationCode("86");
								staffDepartmentRelatedService.add(dto);
							}
						}
					}
				}
			}
			
		}
		
		
	}

	@Override
	public void staffEdit(StaffDTO staffDTO, String departmentIds) {
		TabHaobanStaff oldStaff = staffMapper.selectByPrimaryKey(staffDTO.getStaffId());
		logger.info("【员工修改】oldStaff={}",JSON.toJSONString(oldStaff));
		//1、先更新staff
		TabHaobanStaff tab = EntityUtil.changeEntityByJSON(TabHaobanStaff.class, staffDTO);
		staffService.updateByPrimaryKey(tab);
		
		List<TabHaobanStaffDepartmentRelated> list = staffDepartmentRelatedService.listStaffDepartmentByStaffId(staffDTO.getStaffId());
		Map<String,TabHaobanStaffDepartmentRelated> map = com.gic.commons.util.CollectionUtil.toMap(list, "departmentId");
		//2、该员工新增部门
		if(StringUtils.isNotBlank(departmentIds)){
			String [] addIds = departmentIds.split(",");
			for(String addId : addIds){
				if(!map.containsKey(addId)){
					//该员工新增了部门
					StaffDepartmentRelatedDTO related = new StaffDepartmentRelatedDTO();
					related.setStaffDepartmentRelatedId(UuidUtil.randomUUID());
					related.setStaffId(staffDTO.getStaffId());
					related.setClerkCode(null);
					related.setCreateTime(new Date());
					related.setDepartmentId(addId);
					related.setNationCode(staffDTO.getNationCode());
					related.setPhoneNumber(staffDTO.getPhoneNumber());
					related.setStatusFlag(1);
					related.setUpdateTime(new Date());
					related.setWxUserId(oldStaff.getWxUserId());
					related.setWxEnterpriseId(staffDTO.getWxEnterpriseId());
					staffDepartmentRelatedService.add(related);
				}else{
					//该员工部门没做改变(只更新手机号即可)
					TabHaobanStaffDepartmentRelated related = map.get(addId);
					if(!staffDTO.getPhoneNumber().equals(related.getPhoneNumber())){
						related.setPhoneNumber(staffDTO.getPhoneNumber());
						related.setNationCode(staffDTO.getNationCode());
						related.setUpdateTime(new Date());
						staffDepartmentRelatedMapper.updateByPrimaryKeySelective(related);
					}	
					
					logger.info("【员工修改】related={}",JSON.toJSONString(related));
					if(org.apache.commons.lang3.StringUtils.isNotBlank(related.getClerkCode())){
						logger.info("【员工修改】oldName={},name={}",oldStaff.getStaffName(),staffDTO.getStaffName());
						if(!staffDTO.getPhoneNumber().equals(related.getPhoneNumber())||!staffDTO.getStaffName().equals(oldStaff.getStaffName())){
							TabHaobanDepartment department = departmentService.selectById(addId);
							String enterpriseId = "";
							if(department.getIsStore() == 0){
								com.gic.enterprise.api.dto.DepartmentDTO dto = gicDepartmentService.getDeptment(department.getRelatedId());
								enterpriseId = dto.getEnterpriseId();
							}else{
								StoreDTO store = storeService.getStore(department.getRelatedId());
								enterpriseId = store.getEnterpriseId();
							}
							ClerkDTO clerkDTO= clerkService.getClerkByCodeNoStatus(enterpriseId,related.getClerkCode());
							logger.info("【员工修改】clerkDTO={}",JSON.toJSONString(clerkDTO));
							clerkDTO.setClerkName(staffDTO.getStaffName());
							clerkDTO.setPhoneNumber(staffDTO.getPhoneNumber());
							clerkService.updateClerk(clerkDTO);
						}
					}

				}
			}
		}
		//3、该员工删除部门
		for(TabHaobanStaffDepartmentRelated tab1 : list){
			if(departmentIds == null){
				departmentIds = "";
			}
			//不包含，则说明员工删除了该部门
			if(!departmentIds.contains(tab1.getDepartmentId())){
				StaffDepartmentRelatedDTO related = EntityUtil.changeEntityByJSON(StaffDepartmentRelatedDTO.class, tab1);
				staffDepartmentRelatedService.del(related);
//				if(org.apache.commons.lang3.StringUtils.isNoneBlank(tab1.getClerkCode())){
//					//TODO 通知gic解绑
//					
//				}
			}
		}
		
		WxEnterpriseDTO enterpriseDTO = wxEnterpriseService.selectById(oldStaff.getWxEnterpriseId());
		TabHaobanWxApplication application = wxApplicationService.selectByWxEnterpriseIdAndApplicationType(oldStaff.getWxEnterpriseId(),1);
		if(enterpriseDTO != null) {
			if(application != null) {
				UserDTO userDTO = new UserDTO();
				userDTO.setCorpid(enterpriseDTO.getCorpid());
				
				String[] departmentIdArr = departmentIds.split(",");
				Integer[] wxDepartmentIdArrIntegers = new Integer[departmentIdArr.length];
				int index = 0;
				for (String string : departmentIdArr) {
					TabHaobanDepartment tabs = departmentService.selectById(string);
					wxDepartmentIdArrIntegers[index] = Integer.parseInt(tabs.getWxDepartmentId());
					index ++;
				}
				userDTO.setDepartment(wxDepartmentIdArrIntegers);
				userDTO.setGender(staffDTO.getSex().toString());
				userDTO.setMobile(staffDTO.getPhoneNumber());
				userDTO.setName(staffDTO.getStaffName());
				userDTO.setUserid(oldStaff.getWxUserId());
				JSONResponse jp = qywxUserApiService.updateWorkWxUser(userDTO, enterpriseDTO.getCorpid(), application.getSiteId());
				
			}
		}
	}

	@Override
	public void syscGicClerk(String fieldListString) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public StaffDTO selectByUserId(String userId) {
		return EntityUtil.changeEntityByJSON(StaffDTO.class, staffService.selectByUserId(userId));
	}

	@Override
	public StaffDepartmentRelatedDTO getDepartmentIdAndStaffId(String departmentId, String staffId) {
		TabHaobanStaffDepartmentRelated tab = staffDepartmentRelatedService.getDepartmentIdAndStaffId(departmentId,staffId);
		return EntityUtil.changeEntityByJSON(StaffDepartmentRelatedDTO.class, tab);
	}

	@Override
	public int countByDepartmentId(String departmentId) {
		
		return staffDepartmentRelatedService.countByDepartmentId(departmentId);
	}

	@Override
	public StaffDTO selectSuperByWxEnterpriseId(String wxEnterpriseId) {
		TabHaobanStaff tab = staffMapper.selectSuperByWxEnterpriseId(wxEnterpriseId);
		return EntityUtil.changeEntityByJSON(StaffDTO.class, tab);
	}

	@Override
	public void syncGicClerk(String fieldListString) {
		logger.info("【同步店员】fieldList={}",fieldListString);
		List<SyncJsonColumnDTO> fieldList = JSONArray.parseArray(fieldListString,SyncJsonColumnDTO.class);
		if(fieldList.isEmpty()){
	        return;
	    }
	    String gicStoreId = "";
	    String code = "";
	    String staffName = "";
	    String phoneNumber = "";
	    String nationcode = "";
	    Integer sex = null;
	    String headPic = "";
	    Integer status = null;
	    String postion = "";
	    
	    for (SyncJsonColumnDTO syncJsonColumnDTO:fieldList){
	    	String name = StringUtil.camelName(syncJsonColumnDTO.getName());
	        String value = syncJsonColumnDTO.getValue();
	        
	        if("storeId".equals(name)){
	        	gicStoreId = value;
	        	if(StringUtils.isBlank(gicStoreId)){
	        		return;
	        	}
	        	continue;
	        }
	        
	        if("clerkName".equals(name)){
	        	staffName = value;
	        	continue;
	        }
	        
	        
	        if("clerkCode".equals(name)){
	        	code = value;
	        	continue;
	        }
	        
	        if("clerkGender".equals(name)){
	        	sex = value == null?null:Integer.parseInt(value);
	        	continue;
	        }
	        
	        if("status".equals(name)){
	        	status = value == null?null:Integer.parseInt(value);
	        	continue;
	        }
	        
	        if("headImgUrl".equals(name)){
	        	headPic = value;
	        	continue;
	        }
	        
	        if("phoneNumber".equals(name)){
	        	phoneNumber = value;
	        	continue;
	        }
	        
	        if("postionName".equals(postion)){
	        	postion = value;
	        	continue;
	        }
	        
	        if("nationcode".equals(name)){
	        	if(StringUtils.isBlank(value)){
	        		nationcode = "86";
	        	}else{
	        		nationcode = value;
	        	}
	        	continue;
	        }
	    }
	    
	    if(StringUtils.isBlank(gicStoreId)){
	    	logger.info("【店员同步】gicStoreId为空");
	    	return;
	    }
	    TabHaobanDepartment department = departmentService.selectByRelatedId(gicStoreId);
	    if(department == null){
	    	try {
				Thread.sleep(3 * 1000);
				department = departmentService.selectByRelatedId(gicStoreId);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
	    	if(department == null){
	    		logger.info("【店员同步】department为空");
		    	return;
	    	}
	    }
	    String departmentId = department.getDepartmentId();
	    String wxEnterpriseId  = department.getWxEnterpriseId();
	    StaffDTO staff = this.selectByNationcodeAndPhoneNumber(wxEnterpriseId, nationcode, phoneNumber);
	    
	    if(staff == null){
	    	if(status != 1){
	    		return;
	    	}else{
	    		staff = new StaffDTO();
	    		staff.setWxEnterpriseId(wxEnterpriseId);
	    		staff.setClerkCode(code);
	    		staff.setActiveFlag(1);
	    		staff.setDepartmentIds(departmentId);
	    		staff.setHeadImg(headPic);
	    		staff.setNationCode(nationcode);
	    		staff.setPhoneNumber(phoneNumber);
	    		staff.setNickName(staffName);
	    		staff.setPostion(postion);
	    		staff.setSex(sex);
	    		staff.setStaffName(staffName);
	    		staff.setSyncPostionFlag(1);
	    		HaobanResponse hr = this.add(staff, department.getDepartmentId());
				if(hr.getErrorCode() == 1){
					StaffDepartmentRelatedDTO staffRelated = this.getDepartmentIdAndStaffId(departmentId, hr.getResult().toString());
					StaffDepartmentRelatedDTO isCodeExist = this.getDepartmentIdAndCode(departmentId,code);
					if(staffRelated != null && isCodeExist == null){
						staffRelated.setClerkCode(code);
						staffDepartmentRelatedMapper.updateByPrimaryKey(EntityUtil.changeEntityByJSON(TabHaobanStaffDepartmentRelated.class, staffRelated));
					}
				}
	    	}
	    }else{
	    	String staffId = staff.getStaffId();
	    	//删除
	    	if(status == 0){
	    		StaffDepartmentRelatedDTO staffRelated = this.getDepartmentIdAndStaffId(departmentId, staffId);
	    		if(staffRelated != null){
	    			staffRelated.setClerkCode(null);
					staffDepartmentRelatedMapper.updateByPrimaryKey(EntityUtil.changeEntityByJSON(TabHaobanStaffDepartmentRelated.class, staffRelated));
	    		}
	    	//修改
	    	}else{
	    		staff.setStaffName(staffName);
				List<StaffDepartmentRelatedDTO> relatedList = this.listStaffDepartmentByStaffId(staffId);
				Map<String,StaffDepartmentRelatedDTO> map = com.gic.commons.util.CollectionUtil.toMap(relatedList, "departmentId");
				String departmentIds = "";
				if(map.get(departmentId) == null){
					departmentIds = departmentId;
				}
				for (StaffDepartmentRelatedDTO staffDepartmentRelatedDTO : relatedList) {
					departmentIds += "," + staffDepartmentRelatedDTO.getDepartmentId();
				}
				if(departmentIds.startsWith(",")){
					departmentIds = departmentIds.substring(1,departmentIds.length());
				}
				if(map.get(departmentId) == null){
					this.staffEdit(staff, departmentIds);
				}
				StaffDepartmentRelatedDTO staffRelated = this.getDepartmentIdAndStaffId(departmentId, staffId);
				StaffDepartmentRelatedDTO isCodeExist = this.getDepartmentIdAndCode(departmentId,code);
				//如果这个人是未绑定的 则绑定clerk
				if(StringUtils.isBlank(staffRelated.getClerkCode()) && isCodeExist == null){
					staffRelated.setClerkCode(code);
					staffDepartmentRelatedMapper.updateByPrimaryKey(EntityUtil.changeEntityByJSON(TabHaobanStaffDepartmentRelated.class, staffRelated));
				}
				this.staffEdit(staff, departmentIds);
	    	}
	    	
	    }
	}

	@Override
	public StaffDepartmentRelatedDTO getDepartmentIdAndCode(String departmentId, String code) {
		return EntityUtil.changeEntityByJSON(StaffDepartmentRelatedDTO.class, staffDepartmentRelatedMapper.getDepartmentIdAndCode(departmentId,code));
	}

}
